// 初始化fk2
const fs = require('fs');
const addJson = require('./plug-in/addJSON');
const logs = require('./plug-in/colorLog');
const rrid = require('rrid');
const {task,work,log,server,funct,pkg} = require('./plug-in/fk2Path');
function initAll() {
    // 初始化
    const secret = rrid.key(128);
    const time = new Date().getTime();
    const key = rrid.md5(time.toString());
    const sData = {"http":80,"https":443,auth: false,auto: false,ipList:[],key,secret}
    mkdirSync(work);
    mkdirSync(log);
    mkdirSync(pkg);
    mkdirSync(funct);
    addJson(task);
    addJson(server,sData);
    // 添加开机启动
    require('./startup');
    function mkdirSync(url) {
        if(!fs.existsSync(url)){
            fs.mkdirSync(url);
        }
    }
}
function emptyDir(path) {
    // 清空文件夹和文件
    var files = [];
    try {
        files = fs.readdirSync(path);
    } catch (error) {
        return
    }
    files.forEach(file => {
        const filePath = `${path}/${file}`;
        const stats = fs.statSync(filePath);
        if (stats.isDirectory()) {
            emptyDir(filePath);
        } else {
            try {
                fs.unlinkSync(filePath);
            } catch (error) {

            }
        }
    });
    fs.rmdirSync(path);
}
module.exports = {
    init(){
        // 初始化
        if (!fs.existsSync(work)){
            initAll();
            console.log('\n');
            require('./auth');
            logs.close();
        }else{
            logs.close();
            logs.skyBlue('The initialization has been completed! \n');
            require('./auth');
            logs.close();
        }
    },
    reset(){
        // 恢复初始化
        emptyDir(work);
        initAll();
        logs.close();
        logs.skyBlue('Restore the initial setup! \n');
        require('./auth');
        logs.close();
    }
}
