'use strict';
const os = require('os');
exports.main = async () => { 
    // 定时刷新集群信息
    let res = {code:1};
    const cpus = os.cpus();
    const len = cpus.length;
    let user = 0, nice = 0, sys = 0, idle = 0, irq = 0, total = 0;
    for (const i in cpus) {
        const times = cpus[i].times
        user += times.user;
        nice += times.nice;
        sys += times.sys;
        idle += times.idle;
        irq += times.irq;
    }
    user = user/len;
    nice = nice/len;
    sys = sys/len;
    idle = idle/len;
    irq = irq/len;
    total += user + nice + sys + idle + irq;
    res.cpus = {user,sys,nice,idle,irq,total};
    res.uptime = os.uptime();
    res.freemem = os.freemem();
    res.totalmem = os.totalmem();
    return res;
};