let md5s = null;
const arg = require('../plug-in/arg');
const {decrypt} = require('../plug-in/key');
const checkIp = require('../plug-in/checkClientIp');
const { server } = require('../plug-in/fk2Path');
const serverMd5 = require('../plug-in/serverMd5');
const readJSON = require('../plug-in/readJSON');
const serverCode = require('../plug-in/serverCode');
let rest = { code: 0, msg: 'An unknown error' };
const pathList = require('./pathList');
//不存在域名时，则需要通过ip白名单的url
module.exports = async (req, res, site) => {
    const obj = arg(req);
    const { protocol } = req;
    if (site[obj.headers.host]) {
        // 存在域名时
        if (!site[obj.headers.host][protocol]) {
            // 没有开启协议
            res.json(rest)
        } else {
            // 开启协议

        }
    } else {
        // 不存在域名时
        const { key, secret } = readJSON(server);
        const code = serverCode(key, secret);
        if (code == null) {
            // 验证serverCode
            rest.msg = 'The serverCode error'
            res.json(rest);
            return
        }
        const arr = pathList[obj.url];
        if(!arr) {
            rest.msg = 'The route error！'
            res.json(rest);
            return
        }
        if (arr.includes('ip')) {
            // 验证ip白名单
            if (!checkIp(obj.ip)) {
                // 没通过白名单
                rest.msg = "IP does not exist!"
                res.json(rest);
                return
            }
        }
        if (arr.includes('md5')) {
            // 验证请求md5
            let data = obj.data;
            const md5 = obj.data.md5;
            delete data.md5;
            if (md5s && md5s == md5) {
                // 验证md5值实效性,具有防抖效果
                rest.msg = 'The md5 error！'
                res.json(rest);
                return
            }
            md5s = md5;
            const svmd5 = serverMd5(code, data);
            if (md5 !== svmd5) {
                // 验证fk2传来的md5值实效性
                res.json(rest);
                return
            }
        }
        if (arr.includes('token')) {
            // 验证请求来自客户端的token 
            if(obj.data.token&&obj.data.id){
                // 开始验证
                try {
                    const expired = 10*60*1000;  //token过期时间
                    const time = new Date().getTime();
                    const dres = JSON.parse(decrypt(obj.data.token));
                    const times = time-dres.time;
                    if(dres.code!==code||dres.ip!==obj.ip||times>expired){
                        rest.msg = 'Token expiration！'
                        res.json(rest);
                        return
                    }
                } catch (error) {
                    rest.msg = 'Token validation error！'
                    res.json(rest);
                    return
                }
            }else{
                rest.msg = 'The token error！'
                res.json(rest);
                return
            }
        }
        try {
            const { main } = require('./api' + obj.url);
            res.json(await main(obj));
        } catch (e) {
            rest.msg = e;
            res.json(rest);
        }
    }
}