const fs = require('fs');
const tls = require('tls');
const path = require('path');
const {decrypt} =require('../plug-in/key');
const key = decrypt(fs.readFileSync(path.join(__dirname,'../work/key/ssl.key')).toString());
const cert = decrypt(fs.readFileSync(path.join(__dirname,'../work/key/ssl.pem')).toString());
module.exports = (host) => {
    var getKeyCert = {
        SNICallback: function (domain, cb) {
            if (host[domain]&&host[domain].https) {
                if (cb) {
                    cb(null, KeyCerts(host[domain]));
                } else {
                    return KeyCerts(host[domain]);//兼容Node老版本
                }
            } else {
                //一定要设置默认值，这样访问其他时，也可以访问，只是会有安全性提示
                if (cb) {
                    cb(null, KeyCert({
                        key,
                        cert
                    }));
                } else {
                    return KeyCert({
                        key,
                        cert
                    });
                }
            }
        }, 
        key,
        cert
    };
    return getKeyCert
}
function KeyCerts(obj) {
    return tls.createSecureContext({
        key: decrypt(obj.key),
        cert: decrypt(obj.cert)
    })
}
function KeyCert(obj) {
    return tls.createSecureContext({
        key: obj.key,
        cert: obj.cert
    })
}