const http = require('http');
const https = require('https');
const express = require('express');
const app = express();
app.use(express.json()); //  application/json
app.disable('x-powered-by');//去除x-powered-by响应字段
app.use(express.urlencoded({ extended: true }));// application/x-www-form-urlencoded
const { server } = require('../plug-in/fk2Path');
const readJSON = require('../plug-in/readJSON');
const hosts = readJSON(server);
const myssl = require('./myssl');
const main = require('./main');
// 根据项目的路径导入生成的证书文件
app.all('*', (req, res) => {
    //设置允许跨域的域名，*代表允许任意域名跨域 
    res.header("Access-Control-Allow-Origin", "*");
    //允许的header类型
    res.header("Access-Control-Allow-Headers", "content-type");
    //跨域允许的请求方式 
    res.header("Access-Control-Allow-Methods", "PUT,POST,GET");
    main(req, res, hosts);
})
http.createServer(app).listen(hosts.http ? hosts.http : 80)
https.createServer(myssl(hosts), app).listen(hosts.https ? hosts.https : 443);
