const arg = process.argv;
const os = require('os');
const fs = require('fs');
var cpu = os.cpus().length;
const {md5} = require('rrid');
const logs = require('../plug-in/colorLog');
const {kill,check} = require('../plug-in/psNode');
const {task} = require('../plug-in/fk2Path');
const addJson = require('../plug-in/addJSON');
const readJson = require('../plug-in/readJSON');
const goLogs = require('../plug-in/goLogs');// 写启动日志
const id = arg[2]=='start'?md5(process.cwd()+arg[3]):'run';
module.exports = {
    async mainFun(){
        // 主进程函数
        logs.y('Service is starting , please later ...');
        logs.close();
        var data = readJson(task);
        if(!data) return 0;
        if (arg[2] == 'start') {
            // fk2 start ...
            cpu = cpus(arg[4]); 
        } else {
            require('../auth');// json验证集群是否被绑定
        }
        if(data[id]&&data[id].ppid){
            const res = await check(data[id].ppid);
            if(res) {
                const text = ' already open!';
                logs.r(id=='run'?"'fk2 run'"+text:arg[3]+text);
                logs.close();
                return 0;
            }
        }
        data[id] = {
            cwd: process.cwd(),
            script: id=='run'?'run':arg[3],
            pids:{},
            ppid: process.pid,
            time: new Date().getTime(),
            close:0
        }
        addJson(task,data);
        goLogs(1);//记录日志
        return cpu;
    },
    wkFun(){
        // 工作进程函数
        var data = readJson(task);
        if(!data) return 0;
        data[id].pids[process.pid] = {};
        data[id].pids[process.pid].code = 1;
        addJson(task,data);
        goLogs();
    },
    onExit(pid){
        // 监听退出判断时是否重启 0不重启表示删除
        var data = readJson(task);
        if(!data) return false;
        const res = data[id].pids[pid].code;
        delete data[id].pids[pid];
        addJson(task,data);
        if(res > 0){
            return true;
        }else{
            return false;
        }
    },
    watch(){
        // 监听文件是否有重启动作
        fs.watchFile(task, async(cur, prv) => {
            // 监听文件
            if (cur.mtime !== prv.mtime) {
                var data = readJson(task);
                if(!data) return false;
                if(data[id].close==1){
                    // 退出进程
                    data[id].close=0;
                    addJson(task,data);
                    // 删除进程
                    await kill(data[id].ppid);
                }
                if(data[id].close==0){
                    // 重启或删除进程
                    restart(data[id].pids);
                }
            }
        })
    }    
}
async function restart(pids) {
    // 退出进程 重启或关闭
    if(Object.keys(pids).length>0){
        for (const key in pids) {
            if(pids[key].code==0||pids[key].code==3){
                //重启状态为0或3的进程 
                await kill(key);
            }
        }
        return true
    }else{
        return false
    }
}

function cpus(d) {
    // 判断并且输出单例数
    if(!d&&d!=0){
        cpu = cpu;
    }else if (d == 'max') {
        cpu = cpu;
    } else if (d > 0) {
        cpu = d;
    } else {
        logs.r('Open the failure!');
        logs.close();
        logs.r('The number of processes cannot be greater than '+cpu);
        logs.close();
        cpu = 0;
    }
    return cpu;
}